<template>
  <t-modal
    :value="true"
    :click-to-close="clickToClose"
    :hide-close-button="hideCloseButton"
    class="_t-modal-overlay"
    :variant="variant"
    :variants="tModalStyle.variants"
    :classes="tModalStyle.classes"
    :fixed-classes="tModalStyle.fixedClasses"
    @before-open="beforeOpenHandler"
    @closed="closedHandler"
  >
    <template #header>
      <slot name="header" />
    </template>

    <template #default>
      <slot name="default" />
    </template>

    <template
      v-if="footer"
      #footer
    >
      <slot name="footer">
        <div class="flex flex-col md:flex-row gap-4 justify-center md:pb-4 mt-8">
          <slot name="footerButtons">
            <!-- Default OK button -->
            <VButton
              class="w-full md:w-auto"
              variant="action"
              @click.native="hide()"
            >
              {{ $t('global.ok') | capitalize }}
            </VButton>
          </slot>
        </div>
      </slot>
    </template>
  </t-modal>
</template>

<script>
import { Core } from '@hperchec/scorpion-ui'
import BaseModal from './BaseModal'
// Mixins
import { Variantable, VariantableOptions } from '@/mixins/variantable'
// Component style
import Style from './style'

/**
 * **VModal** component
 */
export default {
  name: 'VModal',
  extends: BaseModal,
  mixins: [
    Variantable
  ],
  props: {
    ...Core.context.services['modal-manager'].Modal.props,
    /**
     * The TModal variant
     */
    variant: {
      type: String,
      default: 'small'
    },
    /**
     * Custom prop to define if modal can be closed on backdrop click
     */
    hideCloseButton: {
      type: Boolean,
      default: false
    },
    /**
     * Custom prop to define if modal can be closed on backdrop click
     */
    clickToClose: {
      type: Boolean,
      default: true
    },
    /**
     * Display footer
     */
    footer: {
      type: Boolean,
      default: true
    }
  },
  computed: {
    /**
     * ⚠ We have to return css classes as STRING because vue-tailwind TModal component
     * does not accept classes as object
     */
    tModalStyle () {
      return new VariantableOptions(this.overriddenStyle, { cssClassesFormat: 'string' })
    }
  },
  methods: {
    beforeOpenHandler (...args) {
      return this.beforeOpen(...args)
    },
    closedHandler (...args) {
      this.hide()
    }
  },
  // Style for variantable
  style: Style
}
</script>

<style lang="scss">
// Override default class
._t-modal-overlay {
  @apply relative; // the parent component (ModalOverlay) has z-index defined for layer management
  @apply w-full;
  @apply h-full;
  @apply overflow-auto;
  @apply bg-opacity-80 #{!important};
}

._side-overlay {
  @apply w-full md:w-80;
  @apply h-full;
  @apply fixed;
  @apply right-0;
  @apply top-0 md:top-14;
  @apply bottom-0;
  @apply right-0;
  @apply overflow-auto;
}
</style>
